import wx


class CheckPanel(wx.Panel):

    def __init__(self, parent, pwrbox, data, type, *args, **kw):

        super().__init__(parent)

        self.parent = parent
        self.pwrbox = pwrbox
        self.data = data
        self.main_sizer = wx.BoxSizer(wx.VERTICAL)
        self.type = type
        for field in data:

            if type == "name":
                item = wx.CheckBox(self, wx.ID_ANY, field['name'], size=(120, 35))
                _id = item.GetId()
                field['id1'] = _id

            elif type == "auto":
                item = wx.CheckBox(self, wx.ID_ANY, field['auto'], size=(100, 35))
                _id = item.GetId()
                field['id2'] = _id
            else:
                return

            item.Bind(wx.EVT_CHECKBOX, self.OnCheck1)
            self.main_sizer.Add(item, proportion=0, flag=wx.ALL, userData=field)
        self.SetSizer(self.main_sizer)

    def update_gui(self, data):
        self.data = data
        for field in data:
            index = field['index']
            item = self.main_sizer.GetItem(index)
            obj = item.GetWindow()
            data, match = self._find_data(obj)
            if obj:
                if match == 1:
                    if field['state'] == "On":
                        obj.SetValue(True)
                    else:
                        obj.SetValue(False)
                if match == 2:
                    if field['auto'] == "Auto":
                        obj.SetValue(True)
                        obj.Label = "Auto"
                    else:
                        obj.SetValue(False)
                        obj.Label = "Manual"

    def _find_data(self, obj):
        _id = obj.GetId()
        items = self.data
        match = 0
        data = None
        try:
            data = next(item for item in items if item["id1"] == _id)
            match = 1
        except StopIteration:
            try:
                data = next(item for item in items if item["id2"] == _id)
                match = 2
            except StopIteration:
                pass
        return data, match

    def OnCheck1(self, event):
        obj = event.EventObject
        data, match = self._find_data(obj)

        if data['type'] == 'pwr':
            if match == 1:
                if obj.IsChecked():
                    self.pwrbox.set_chnl_state(data['index'], 1)
                else:
                    self.pwrbox.set_chnl_state(data['index'], 0)
            elif match == 2:
                if obj.IsChecked():
                    self.pwrbox.set_auto_pwron(data['index'], 1)
                    obj.Label = "Auto"
                else:
                    self.pwrbox.set_auto_pwron(data['index'], 0)
                    obj.Label = "Manual"

        elif data['type'] == 'htr':
            if match == 1:
                if obj.IsChecked():
                    self.pwrbox.set_htr_state(data['index'], 1)
                else:
                    self.pwrbox.set_htr_state(data['index'], 0)
            elif match == 2:
                if obj.IsChecked():
                    self.pwrbox.set_auto_htr(data['index'], 1)
                    obj.Label = "Auto"
                else:
                    self.pwrbox.set_auto_htr(data['index'], 0)
                    obj.Label = "Manual"
